<template>
    <div>
        <div v-if="campaigns.data.length">
            <div class="table-title">
                Scheduled
            </div>
            <div class="table-responsive">
                <table class="table-hover">
                    <thead class="table-header">
                        <tr>
                            <th class="table-first-item">
                                Message's text
                            </th>
                            <th>Created on</th>
                            <th />
                        </tr>
                    </thead>
                    <tbody class="table-body">
                        <tr
                            v-for="(value, index) in campaigns.data"
                            :key="index"
                            class="table-body-row"
                        >
                            <th class="table-first-item">
                                {{ value.body_text.length >= 50?value.body_text.slice(0, 50) + '...' : value.body_text }}
                            </th>
                            <th>{{ $formatter.dateFormat(value.created_at) }}</th>
                            <th class="text-right">
                                <router-link
                                    :to="'/sms/campaigns/edit/' + value.id"
                                    class="btn light-blue-btn"
                                >
                                    Edit
                                </router-link>
                                <b-btn
                                    class="red-button"
                                    @click="deleteCampaign(value.id)"
                                >
                                    Remove
                                </b-btn>
                            </th>
                        </tr>
                    </tbody>
                </table>
            </div>
            <pagination
                :data="campaigns"
                @pagination-change-page="getResults"
            />
        </div>
        <div
            v-else
            class="row row-container"
        >
            <div class="col-md-8">
                Scheduled Campaigns will send based on specific times you have set
            </div>
            <div class="col-md-4 not-found">
                You have no <span>Scheduled Campaigns</span>
            </div>
        </div>
    </div>
</template>

<script>
    import smsCampaign from '../../../mixins/sms/campaigns.service';

    export default {
        name: "CampaignsTable",
        mixins: [smsCampaign],
        data() {
            return {
                campaigns: {data: []}
            }
        },
        mounted() {
            this.getResults();
        },
        methods: {
            deleteCampaign: function (id) {
                this.delete(id).then(response => {
                    this.$notify({
                        type: 'success',
                        title: 'Deleted'
                    });
                }).finally(this.getResults());
            },
            getResults: function (pageNum = 1, perPage = 5) {
                this.getAllCampaigns(pageNum, perPage).then(response => (this.campaigns = response.data)).catch(error => {
                    console.log(error)
                });
            }
        }
    };
</script>
<style scoped lang="scss">


.table-title {
    font-size: 28px;
    font-weight: bold;
    margin-left: 13px;
    margin-top: 45px;
}

.row-container {
    margin-top: 40px;
}

.not-found {
    font-size: 18px;
    color: #b3b9c4;
    font-weight: 900;
    text-align: right;
}

.table-status-complete {
    color: #2BB300;
}

.not-found span {
    color: #03183B;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
}

.subtitle {
    font-size: 11px;
}

.title-container {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 25px;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        align-items: baseline;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 15px;
    }
}

.my-icon {
    color: white;
    margin-right: 8px;
    font-size: 17px;
}

.table-first-item {
    text-align: start !important;
}

.table-hover tr {
    border-bottom: 3px solid #F5F6FA;
    border-radius: 10px;
}

.table-header {
    padding: 10px;
}

.table-body {
    background: white;
    border-radius: 10px;
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}


</style>
